/********************************** (C) COPYRIGHT *******************************
* File Name          : CH379INC.C
* Author             : MJX
* Version            : V1.00
* Date               : 2021/03/20
* Description        : C Define for CH379
*					   Website: http://wch.cn
*					   Email:   tech@wch.cn 		
*******************************************************************************/



#ifndef __CH379INC_H__
#define __CH379INC_H__

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************/
/* оƬ汾 */					
#define	DEF_CH379_VER		  	   0x30							 				/* ǰоƬ̼汾,2λΪоƬ汾,6λΪ̼汾 */

/***********************************************************************************************************************/
/* ͺͳ */

#ifndef		TRUE
#define		TRUE	1
#define		FALSE	0
#endif
#ifndef		NULL
#define		NULL	0
#endif

#ifndef UINT8
typedef unsigned char              UINT8;
#endif
#ifndef UINT16
typedef unsigned short             UINT16;
#endif
#ifndef UINT32
typedef unsigned long              UINT32;
#endif
#ifndef PUINT8
typedef unsigned char              *PUINT8;
#endif
#ifndef PUINT16
typedef unsigned short             *PUINT16;
#endif
#ifndef PUINT32
typedef unsigned long              *PUINT32;
#endif
#ifndef UINT8V
typedef unsigned char volatile     UINT8V;
#endif
#ifndef PUINT8V
typedef unsigned char volatile     *PUINT8V;
#endif

/* ********************************************************************************************************************* */
/* ˵: 
   (1)CH372оƬ, ݻݵĿֲܾͬ;
   (2)һ˳:
          aһ(ڴڷʽ,֮ǰҪͬ);
          bɸ(0);
          cж֪ͨɸ(0), ѡһ, ж֪ͨһû, һж;
             CMD01_WR_REQ_DATA, ˳: һ, һ, ɸ   
   (3): CMDxy_NAME
        еxy, x˵ݸ(ֽ), y˵ݸ(ֽ), yH˵ж֪ͨ,
        Щܹʵ0ֽڵݿд, ݿ鱾ֽδxy֮ */

/* ********************************************************************************************************************* */
/* Ҫ(ֲһ), , ڲʱж֪ͨ */

#define	CMD01_GET_IC_VER		   0x01							 /* ȡоƬ̼汾 */
/* : 汾( λ7Ϊ0, λ6Ϊ1, λ5~λ0Ϊ汾 ) */
/*       CH379ذ汾ŵֵΪ040H汾Ϊ00H */

#define	CMD31_SET_BAUDRATE		   0x02							 /* ڷʽ: ôͨѶ(ϵ߸λĬϲΪ9600bps,SCK/SDI/SDOѡ) */
/* : 3ֽڲϵ,ֽǰ */
/* : ״̬( CMD_RET_SUCCESSCMD_RET_ABORT, ֵ˵δ ) */

#define	CMD10_ENTER_SLEEP		   0x03							 /* ˯״̬ */
/* : 1ֽڲ, Ϊ0x11,ʹоƬ˯״̬,֮USBܿԼʹ;
                      Ϊ0x22,ʹоƬ˯״̬,֮USB豸,Ҫȫ³ʼ; */

#define	CMD00_RESET_ALL			   0x05							 /* ִӲλ */

#define	CMD11_CHECK_EXIST	       0x06							 /* ͨѶӿں͹״̬ */
/* :  */
/* : ݵİλȡ */

#define	CMD11_SET_USB_MODE		   0x15							 /* USBģʽ */
/* : ģʽ */
/*       00H=δõ豸ʽ, 01H=õ豸ʽʹⲿ̼ģʽ, 02H=õ豸ʽʹù̼ģʽ */
/*       03H=SDģʽ/δõģʽ,ڹʹȡSDеļ */
/*       04H=SDģʽ/õģʽ,ڹʹȡSDеļ */
/*       05H=δõʽ */
/*       06H=USBģʽ/δõģʽ,ڹʹȡUSB洢豸еļ */
/*       07H=USBģʽ/õģʽ,ڹʹȡUSB洢豸еļ */
/* : ״̬( CMD_RET_SUCCESSCMD_RET_ABORT, ֵ˵δ ) */

#define	CMD01_GET_STATUS		   0x22							 /* ȡж״̬ȡж */
/* : ж״̬ */


/* ********************************************************************************************************************* */
/* Ҫ(ֲ), ǳ, ڲʱж֪ͨ */

#define	CMD20_BULK_WR_TEST		   0x07							 /* дݲ */
/* : 2ֽںݳ,Nֽں */

#define	CMD20_BULK_RD_TEST		   0x08							 /* ݲ */
/* : 2ֽںݳ */
/* : Nֽں */

#define	CMD02_GET_REAL_LEN		   0x0E							 /* ٷһִϺ󳤶Ӧʵʳ */
/* : 4ֽʵ, ֽǰ */
/* ע: ʹֽڶλֽڶдλдʱʹ,Լӿִٶ  */

/* ********************************************************************************************************************* */
/* USB豸ģʽ */

#define	CMD40_SET_USB_ID		   0x11							 /* USBVIDͲƷPID */
/* : 4ֽVID\PID,ֱΪIDֽ, IDֽ, ƷIDֽ, ƷIDֽ */
/* עCMD11_SET_USB_MODEǰ */

#define	CMD10_SET_USB_SPEED		   0x13							 /* USBٶ */
/* : 1ֽUSBٶֵ,0x00Ϊȫ,0x02Ϊ,ֵЧ */
/* עCMD11_SET_USB_MODEǰ */

#define	CMD01_GET_USB_SPEED		   0x14							 /* ȡUSBٶ */
/* : 1ֽڵUSBٶֵ, 0x00Ϊȫ,0x02Ϊ,ֵЧ */

#define	CMD70_INIT_ENDPx		   0x17							 /* USB˵(˵xΧ: 1--4) */
/* : 1ֽUSB˵: 1--4, 1ֽڶ˵, 1ֽڶ˵, 1ֽڶ˵㷽, 2ֽС(ֽǰ),1ֽڵж״̬  */
/* עCMD11_SET_USB_MODEǰ */

#define	CMD20_SET_INDEXx_IN		   0x18							 /* USB IN˵x(xΧ: 0--4)Ľ */
/* : 1ֽ, 1ֽڹʽ */
/*           λ7Ϊ1λö˵ͬλ
             λ6Ϊ1øö˵ӦʽΪSTALL
			 λ5Ϊ1ö˵֮ǰSTALLԣ
			 ʵϴ,оƬԶӦNAK */

#define	CMD20_SET_INDEXx_OUT	   0x19						 	 /* USB OUT˵x(xΧ: 0--4)ķ */
/* : 1ֽ, 1ֽڹʽ */
/*           λ7Ϊ1λö˵ͬλ
             λ6Ϊ1øö˵ӦʽΪSTALL
			 λ5Ϊ1ö˵֮ǰSTALLԣ
			 յ´ݰ,оƬԶӦACK */

#define	CMD10_UNLOCK_USB		   0x23							 /* ͷŵǰUSB */
/* : 1ֽUSB˵: 0--4 */

#define	CMD1x_RD_USB_DATA		   0x29							 /* ָUSBжϵĶ˵㻺ȡݿ,ͷŻ */
/* : 1ֽUSB˵: 0--4 */
/* : 2ֽڵݳ,  */

#define	CMD30_WR_USB_DATA	       0x2A							 /* ֮USB˵ķͻдݿ */
/* : 1ֽUSB˵: 1--4; 2ֽڵݳ; Nֽڵ */

#define	CMD10_WR_USB_DATA0	       0x2B							 /* USBƶ˵ķͻдݿ */
/* : 1ֽڵݳ; Nֽڵ */


/* ********************************************************************************************************************* */
/* USB豸ģʽٶȶ */
#define USB_DEV_SPEED_FS		   0x00							 /* ǰΪȫ豸 */
#define USB_DEV_SPEED_HS		   0x02							 /* ǰΪ豸 */

/* ˵ */
#define ENDP_INDEX_0       		   0x00							 /* ˵0ƶ˵ */ 	
#define ENDP_INDEX_1       		   0x01							 /* ˵1Զ˵ */
#define ENDP_INDEX_2       		   0x02							 /* ˵2Զ˵ */
#define ENDP_INDEX_3       		   0x03							 /* ˵3Զ˵ */
#define ENDP_INDEX_4       		   0x04							 /* ˵4Զ˵ */	

/* ˵㴫䷽ */
#define ENDP_DIR_IN		    	   0x00							 /* ϴ˵ */
#define ENDP_DIR_OUT			   0x01							 /* ´˵ */

/* ˵ */
#define ENDP_TYPE_RESERVED		   0x00							 /*  */
#define ENDP_TYPE_ISO			   0x01					 		 /* ͬ */
#define ENDP_TYPE_BULK			   0x02							 /*  */
#define ENDP_TYPE_INTERRUPT		   0x03							 /* жϴ */

/* ********************************************************************************************************************* */
/* оƬ˯ģʽ */
#ifndef	HALF_SLEEP_MODE
#define	HALF_SLEEP_MODE	   		   0x11							 /* ˯״̬,֮USBܿԼʹ  */
#define	FULL_SLEEP_MODE			   0x22							 /* ˯״̬,֮USB豸,Ҫȫ³ʼ */
#endif

/* ********************************************************************************************************************* */
/* ڷʽ, ǰͬ */
#ifndef	SER_CMD_TIMEOUT
#define	SER_CMD_TIMEOUT		       32						     /* ʱʱ, λΪmS, ֮ͬ估֮ͬļӦþ, ʱĴʽΪ */
#define	SER_SYNC_CODE1			   0x57							 /* ĵ1ͬ */
#define	SER_SYNC_CODE2			   0xAB				 	 	     /* ĵ2ͬ */
#define	SER_TIMEOUT_RET			   0x03FFFA				 	 	 /* ڽճʱ */
#endif


/* ********************************************************************************************************************* */
/* ״̬ */
#ifndef	CMD_RET_SUCCESS
#define	CMD_RET_SUCCESS			   0x51						  	 /* ɹ */
#define	CMD_RET_ABORT			   0x5F						     /* ʧ */
#define	CMD_PARAME_ERR			   0x5E						     /*  */
#define	CMD_IDENTIFY_ERR		   0x5D						     /* ޸ */
#define	CMD_TIMEOUT_ERR		   	   0x5C						     /* ʱ */
#endif


/* ********************************************************************************************************************* */
/* CH379ж״̬ */
#ifndef	USB_INT_WAKE_UP
#define	USB_INT_WAKE_UP		       0xE0						  	 /* CH379ж״̬ */
#endif


/* ********************************************************************************************************************* */
/* USBж״̬ */

/* ״̬0XHUSB豸ʽ */
/*   ù̼ģʽֻҪ: USB_INT_INDEX1_IN, USB_INT_INDEX2_OUT, USB_INT_INDEX3_IN, USB_INT_INDEX4_OUT */
/*   λ7-λ5Ϊ000 */
/*   λ4-λ3ָʾǰ, 00=OUT, 10=IN, 11=SETUP */
/*   λ2-λ0ָʾǰ˵, 000=0Ŷ˵, 001=1Ŷ˵, 010=2Ŷ˵,011=3Ŷ˵,100=4Ŷ˵, 101=USB, 110=USB߸λ */
/*   ˵Ϊ0ʱΪ˵0(ƶ˵), ˵Ϊ1-4ʱΪ˵, ˵š˵͡˵С˵㷽ڶ˵ʱ */

#define	USB_INT_EP0_SETUP	       0x18							 /* USB˵0SETUP */
#define	USB_INT_EP0_OUT		       0x00							 /* USB˵0OUT */
#define	USB_INT_EP0_IN		       0x10							 /* USB˵0IN */
#define	USB_INT_INDEX1_OUT	       0x01							 /* USB 1Ŷ˵OUT */
#define	USB_INT_INDEX1_IN	       0x11							 /* USB 1Ŷ˵IN */
#define	USB_INT_INDEX2_OUT	       0x02							 /* USB 2Ŷ˵OUT */
#define	USB_INT_INDEX2_IN	       0x12							 /* USB 2Ŷ˵IN */
#define	USB_INT_INDEX3_OUT	       0x03							 /* USB 3Ŷ˵OUT */
#define	USB_INT_INDEX3_IN	       0x13							 /* USB 3Ŷ˵IN */
#define	USB_INT_INDEX4_OUT	       0x04							 /* USB 4Ŷ˵OUT */
#define	USB_INT_INDEX4_IN	       0x14							 /* USB 4Ŷ˵IN */
#define	USB_INT_BUS_SUSP	       0x05							 /* USB߹ */
#define	USB_INT_BUS_RESET	       0x06							 /* USB߸λ */
#define	USB_INT_SET_CONFIG	       0x07							 /* USBյSET_CONFIG */



/* ********************************************************************************************************************* */

#ifdef __cplusplus
}
#endif

#endif
